<template>
  <b-container fluid>
    <b-overlay :show="loading" rounded="sm">
      <ProfileForm
        v-if="!loading"
        :preloadedValues="preloadValues"
        @person-saved="onProfileSaved"
      />
    </b-overlay>
  </b-container>
</template>

<script>
import { mapState, mapActions } from "vuex";
import ProfileForm from "@/components/ProfileForm";
export default {
  name: "profile-view",
  components: {
    ProfileForm
  },
  data() {
    return {
      loading: false,
      preloadValues: {}
    };
  },
  computed: {
    ...mapState({
      person: state => state.person.person,
      persons: state => state.person.persons
    })
  },
  created() {
    this.getPerson();
  },
  methods: {
    ...mapActions({
      SWITCH_LOGISTICS_PERSON: "person/SWITCH_LOGISTICS_PERSON",
      LOAD_LOGISTIC_PERSON_REGIONS: "person/LOAD_LOGISTIC_PERSON_REGIONS",
      LOADING_START: "apphealth/LOADING_START",
      LOADING_DONE: "apphealth/LOADING_DONE"
    }),
    onProfileSaved(person) {
      this.LOADING_START();
      // switch vuex and localstorage to person
      this.SWITCH_LOGISTICS_PERSON(person).then(() => {
        // after switching, load regions
        this.LOAD_LOGISTIC_PERSON_REGIONS().then(
          res => {
            if (res.data.count <= 0) {
              this.LOADING_DONE();
              if (this.$route.name != "noRegions") {
                this.$router.push({ name: "noRegions" });
              }
              return;
            }

            // todo: refresh current view
            if (this.$route.name == "noRegions") {
              this.$router.push({ name: "dashboard" });
              this.LOADING_DONE();
              return;
            }
            this.$router.go();
          },
          () => {
            // error al cargar regiones, un 404 significa
            // que no tiene regiones
            this.LOADING_DONE();
            if (this.$route.name != "noRegions") {
              this.$router.push({ name: "noRegions" });
            }
            return;
          }
        );
      });
    },
    getPerson() {
      this.loading = true;
      const uri = this.$parseurl("/logistica/basic/person/", undefined, {
        role: 3
      });
      this.$fetchget(uri).then(res => {
        res.json().then(data => {
          if (res.ok) {
            if (data.count) {
              data.results.forEach(person => {
                if (person.role == 3) {
                  this.preloadValues = person;
                }
              });
            }
          }
          this.loading = false;
        });
      });
    }
  }
};
</script>
